<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE document PUBLIC
  "-//Apache Software Foundation//DTD XDOC 1.0//EN"
  "http://maven.apache.org/dtd/xdoc_1_0.dtd">

<document>
  <properties>
    <title>設計方針 - Design Concept</title>
    <author email="kurokkie@users.sourceforge.jp">kurokkie</author>
  </properties>
  <body>
    <section name="United Front 2　の設計方針">
      <p>
United Front 2 はゲームという性質上、内部構造が非常に複雑化します。複雑さに対応するための手段として、
オブジェクト指向設計、契約による設計、依存性の注入などの手法が挙げられます。
      </p>
      <subsection name="POJO を中心とするオブジェクト指向設計">
        <p>
United Front 2 では、<strong>オブジェクト指向プログラミング</strong> を中心としたアーキテクチャを採
用しています。単に継承やポリモフィズムといったオブジェクト指向プログラミングの機能を使うというだけではなく、振る
舞いとデータの両方をカプセル化したオブジェクトモデル群を構成することで、<strong>単一責任の原則</strong>
を守った凝縮度の高いシステムを構築可能にしています。また、オブジェクト指向設計における種々のデザインパターン
を適用しやすくするために、中核となるクラスは <strong>POJO</strong> (<strong>P</strong>lain
<strong>O</strong>ld <strong>J</strong>ava <strong>O</strong>bject) で設計していま
す。データアクセス可能な POJO のドメインモデルは、軽量でありながら高機能です。
        </p>
        <div style="text-align: right">詳しくは <a href="domain.html">ドメイン層</a> を参照</div>
      </subsection>
      <subsection name="テストと一体化した契約による設計">
        <p>
United Front 2 では、全面的に <strong>契約による設計</strong> を採用しています。契約による設計は
信頼性の高いソフトウェアを構築するための優れた手法です。契約による設計では、クラス間の関係は互いの権利と義
務を表す正式な同意であると見なし、クラス同士が結んだ契約は <strong>表明</strong> という形で定義されま
す。Java においては、表明の実装として <code>assert</code> 文が用意されていますが、この使用はそれほ
ど一般的ではないようです。そこで United Front 2 では、表明を JavaDoc 中に記述し、それを検証する
<a href="http://www.junit.org/">JUnit</a> テストコードを作成することで契約による設計を実装して
います。これにより、契約による設計という一貫した方式で実装された高品質で再利用可能なテストが、システム全体
を通して適用されることになります。
        </p>
        <div style="text-align: right">詳しくは <a href="dbc.html">契約による設計</a> を参照</div>
      </subsection>
      <subsection name="DI コンテナを使った依存性の注入">
        <p>
システムの構成管理には <a href="http://www.springframework.org/">Spring Framework</a>
の <strong>DI コンテナ</strong> を使っています。United Front 2 アプリケーションは非常に複雑な構
造を持つことになりますが、この複雑さは DI コンテナによって実行時に構成されます。単独の Java コードは実行時
に生じるような依存の連鎖から分離されることになるため、独立性が増し、軽量で設計しやすく、テストしやすいクラスに
なります。依存性の注入は上述のオブジェクト指向設計や契約による設計を実現する上で重要な手法になります。な
お、DI コンテナ以外でも、United Front 2 では一貫して Spring 製品を採用しています。
        </p>
      </subsection>
    </section>
    <section name="参考文献">
      <p>United Front 2 のアーキテクチャが参考としている文献をいくつか挙げておきます。必要に応じて参照してください。</p>
      <ul>
        <li><a href="http://www.amazon.co.jp/dp/4798111112/">オブジェクト指向入門 第2版 原則・コンセプト</a>, バートランド・メイヤー著</li>
        <li><a href="http://www.amazon.co.jp/dp/4798105538/">エンタープライズ アプリケーションアーキテクチャパターン</a>, マーチン・ファウラー著</li>
        <li><a href="http://www.amazon.co.jp/dp/4797322888/">実践J2EEシステムデザイン</a>, ロッド・ジョンソン著</li>
      </ul>

<script type="text/javascript">
var ID='100354378-design';
var AD=1;
var FRAME=0;
</script>
<script src="http://j1.ax.xrea.com/l.j?id=100354378" type="text/javascript"></script>
<noscript>
<a href="http://w1.ax.xrea.com/c.f?id=100354378" target="_blank"><img src="http://w1.ax.xrea.com/l.f?id=100354378&amp;url=X" alt="AX" border="0"/></a>
</noscript>

    </section>
  </body>
</document>
